/*

OSEPP MOTOR DRIVER
 
 Example sketch that allows reverse of the motors polarity to change the direction of the shaft
 (change if the motor moves 'forward' or 'reverse' ). Based off the L9110 IC chip.
 
 without button pressed, motor moves one direction. Once button is held, motor moves another.
 potentiometer knob added to adjust the speed of the motor. 
 
 Written by Daniel @ OSEPP Technical Support. 
 
 */


// constants won't change. They're used here to 
// set pin numbers:
const int buttonPin = 11;     // the number of the pushbutton pin
const int STATUS_LED = 13;
const int MOTOR_FORWARD =  9;      // INA of motor driver board
const int MOTOR_REVERSE =  6;      // INB of motor driver board
const int POT = A0; // potentimeter pin.

int MOTOR_SPEED;
int MOTOR_MIN_SPEED = 0;
int MOTOR_MAX_SPEED = 150; //can adjust to 255 for full motor speed. 
int POT_VAL;
int buttonState = 0;         // variable for reading the pushbutton status


void setup() {

  pinMode(STATUS_LED,OUTPUT); //on board status LED
  pinMode(MOTOR_FORWARD,OUTPUT); 
  pinMode(MOTOR_REVERSE,OUTPUT); 
  // initialize the pushbutton pin as an input:
  pinMode(buttonPin, INPUT);  

}

void loop(){
  // read the state of the pushbutton value:
  buttonState = digitalRead(buttonPin);
  // assign value POT_VAL to read values from POT pin.
  POT_VAL = analogRead(POT); 
  // assign the range of variable MOTOR_SPEED to 'map' the values of the potentiometer to the values of our set motor speed
  MOTOR_SPEED = map (POT_VAL, 0, 1023, MOTOR_MIN_SPEED, MOTOR_MAX_SPEED);

  if(buttonState== LOW ){ 
    //switch direction of motor with button press
  //then change speed of motor with knob.
    analogWrite(MOTOR_FORWARD, MOTOR_SPEED);  //trigger forward pin
    digitalWrite(MOTOR_REVERSE, LOW);
    digitalWrite(STATUS_LED, HIGH);

  }

  if (buttonState==HIGH ){

    analogWrite(MOTOR_REVERSE, MOTOR_SPEED);  //trigger reverse pin
    digitalWrite(MOTOR_FORWARD, LOW);
    digitalWrite(STATUS_LED, LOW);
  }

  delay(1000);

} //end routine


